include \masm32\include\masm32rt.inc
.586	
include \masm32\macros\timers.asm

jeven MACRO value, lbl
	mov eax, value
	test eax, 1
	jz lbl
ENDM

.data
VarOdd	dd 1234567
VarEven	dd 1234568

.code
AppName	db "Masm32:", 0

start:
	Loops=10000000

	invoke Sleep, 1000
	mov edi, -1
	mov ebx, 1234567
	mov esi, 12345678
	counter_begin Loops, HIGH_PRIORITY_CLASS
		REPEAT 50
		test edi, 1
		jz @F
		nop
	 @@:
		test VarOdd, 1
		jz @F
		nop
	 @@:
		test VarEven, 1
		jz @F
		nop
	 @@:
		test ebx, 1
		jz @F
		nop
	 @@:
		test esi, 1
		jz @F
		nop
	 @@:
	;	test 12345, 1	; not possible, therefore
	;	jz @F			; we replace it with the 
		nop				; programmer's judgment that
	 @@:				; 12345 is always odd
		ENDM
	counter_end
	print str$(eax)," cycles, test xxx, 1",13,10

	counter_begin Loops, HIGH_PRIORITY_CLASS
		REPEAT 50
		mov eax, edi
		test eax, 1
		jz @F
		nop
	 @@:
		mov eax, VarOdd
		test eax, 1
		jz @F
		nop
	 @@:
		mov eax, VarEven
		test eax, 1
		jz @F
		nop
	 @@:
		mov eax, ebx
		test eax, 1
		jz @F
		nop
	 @@:
		mov eax, esi
		test eax, 1
		jz @F
		nop
	 @@:
		mov eax, 12345
		test eax, 1
		jz @F
		nop
	 @@:
		ENDM
	counter_end
	print str$(eax)," cycles, mov eax, xxx, test eax, 1",13,10
	exit

IsOdd proc value:dword
	mov eax, value
	and eax, 1
	ret
IsOdd endp

end start

RichMasm options:
OPT_Linker	polink
OPT_Wait	1
OPT_Tmp2Asm	1
